// guh

local cv_fwaid = CV_RegisterVar({"freindly_aid", "On", CV_SAVE, CV_OnOff})

local function isInBattle(player)
	local battleGT = {GT_ARENA, GT_TEAMARENA, GT_SURVIVAL, GT_TEAMSURVIVAL, GT_BATTLECTF, GT_CP, GT_TEAMCP, GT_DIAMOND, GT_TEAMDIAMOND}
	for _,k in ipairs(battleGT) do
		if (gametype == k) return true end
	end
	return false
end

local function canBeNerfed(player)
	if (CV_FindVar("freindly_nerf").value == 1)
		if (gametyperules & GTR_RINGSLINGER)
		or (gametyperules & GTR_TAG)
		or (isInBattle(player))
		or (gametyperules & GTR_RACE)
			return true
		else
			return false
		end
	else
		return false
	end
end

COM_AddCommand("freindly_menu", function(player)
	if (player.mo and player.mo.valid and P_IsObjectOnGround(player.mo) and (player.playerstate == PST_LIVE) and (player.speed < FRACUNIT))
		if player.powers[pw_flashing]
		or player.powers[pw_invulnerability]
			CONS_Printf(player, "MOVE")
			return
		end
		player.freindlymenu_settings = {0, 0}
		if (player.freindlymenu == nil)
			player.freindlymenu = 1
			COM_BufInsertText(player, "tunes frmenu")
		else
			if (player.freindlymenu == 1)
				player.freindlymenu = 0
				COM_BufInsertText(player, "tunes -default")
				player.powers[pw_invulnerability] = TICRATE
			else
				player.freindlymenu = 1
				COM_BufInsertText(player, "tunes frmenu")
			end
		end
	else
		CONS_Printf(player, "MOVE")
	end
end)

local function kys(player, dir, value, limit, default, changemusic)
	if (player.cmd.forwardmove == dir) 
		if (player.friendlymenu_pressed == 0)
			if (changemusic == true)
				COM_BufInsertText(player, "tunes frmenu")
			end
			player.friendlymenu_pressed = 1
			S_StartSound(nil,sfx_fscrol,player)
			player.freindlymenu_settings[1] = $ + value
			if (player.freindlymenu_settings[1] == limit)
				player.freindlymenu_settings[1] = default
			end
		end
	else
		if (player.cmd.forwardmove == 0) 
			player.friendlymenu_pressed = 0
		end
	end
end

local function movements(player, dir, value, typer)
	if (player.cmd.sidemove == dir) 
		player.friendlymenu_sidepressed = $ + 1
		if (player.friendlymenu_sidepressed == 1)
		or (player.friendlymenu_sidepressed >= TICRATE/2)
			if (typer == 0)
				if (player.freindlymenu_settings[2] != 1) return end
				S_StartSound(nil,sfx_fscrol,player)
				player.freindlyamount = $ + value
				if (player.freindlyamount < 1) player.freindlyamount = 1 end
			else
				if (player.freindlymenu_settings[2] != 2) return end
				S_StartSound(nil,sfx_fscrol,player)
				if (player == server or IsPlayerAdmin(player))
					COM_BufInsertText(server, "freindly_roamerforceamount "+tostring(CV_FindVar("freindly_roamerforceamount").value+value))
				end
			end
		end
	else
		if (player.cmd.sidemove == 0) 
			player.friendlymenu_sidepressed = 0
		end
	end
end

addHook("PreThinkFrame", do
	for player in players.iterate()
		if (player.mo and player.mo.valid and player.mo.skin == "freindlyfellow" and player.freindlymenu == 1)
			player.friendlymenu_pressed = $ or 0
			player.friendlymenu_sidepressed = $ or 0
			player.friendlymenu_confirmpressed = $ or 0
			player.friendlymenu_refusepressed = $ or 0

			//MAIN SETTINGS
			if (player.freindlymenu_settings[2] == 0)
				if (abs(player.cmd.forwardmove) == 50) 
					if (player.friendlymenu_pressed == 0)
						player.friendlymenu_pressed = 1
						S_StartSound(nil,sfx_fscrol,player)
						if player.freindlymenu_settings[1] == 0
							player.freindlymenu_settings[1] = 1
						else
							player.freindlymenu_settings[1] = 0
						end
					end
				else
					player.friendlymenu_pressed = 0
				end
				if (player.cmd.buttons & BT_JUMP)
					if (player.friendlymenu_confirmpressed == 0)
						player.friendlymenu_confirmpressed = 1
						
						if (player.freindlymenu_settings[1] == 0)
							player.freindlymenu_settings[2] = 1
							S_StartSound(nil,sfx_fconfm,player)
							player.freindlymenu_settings[1] = 0
						else
							if (player == server or IsPlayerAdmin(player))
								player.freindlymenu_settings[2] = 2
								S_StartSound(nil,sfx_fconfm,player)
								player.freindlymenu_settings[1] = 0
							else
								CONS_Printf(player, "you aren't who i'm looking for")
								S_StartSound(nil,sfx_fbwomp,player)
							end
						end
					else
						player.friendlymenu_confirmpressed = 0
					end	
				end
				if (player.cmd.buttons & BT_USE)
					if (player.friendlymenu_refusepressed == 0)
						player.freindlymenu = 0
						S_StartSound(nil,sfx_frefus,player)
						COM_BufInsertText(player, "tunes -default")
						
						player.powers[pw_invulnerability] = TICRATE
					end
				else
					player.friendlymenu_refusepressed = 0
				end
			end
			
			//USER BASED SETTINGS
			if (player.freindlymenu_settings[2] == 1)
				if not (player == server or IsPlayerAdmin(player))
					player.freindlymenu_settings[2] = 0
					player.freindlymenu_settings[1] = 0
					CONS_Printf(player, "you aren't who i'm looking for")
					S_StartSound(nil,sfx_fbwomp,player)
				end
				kys(player, -50, 1, 5, 0, true)
				kys(player, 50, -1, -1, 4, true)
				if (player.freindlymenu_settings[1] == 0)
					movements(player, 50, 1, 0, 0)
					movements(player, -50, -1, 0)
				end
				if (player.cmd.buttons & BT_JUMP)
					if (player.friendlymenu_confirmpressed == 0)
						S_StartSound(nil,sfx_fconfm,player)
						player.friendlymenu_confirmpressed = 1
						
						if (player.freindlymenu_settings[1] == 1)
							if (CV_FindVar("freindly_music").value)
								COM_BufInsertText(player, "freindly_music 0")
							else
								COM_BufInsertText(player, "freindly_music 1")
							end
						end
						
						if (player.freindlymenu_settings[1] == 2)
							if (CV_FindVar("freindly_aid").value)
								COM_BufInsertText(player, "freindly_aid 0")
								CONS_Printf(player, "Control aid has been disabled")
							else
								COM_BufInsertText(player, "freindly_aid 1")
								CONS_Printf(player, "Control aid has been enabled")
							end
						end
						
						if (player.freindlymenu_settings[1] == 3)
							COM_BufInsertText(player, "freindly_save")
							CONS_Printf(player, "Saved options")
						end
						
						if (player.freindlymenu_settings[1] == 4)
							COM_BufInsertText(player, "freindly_load")
							CONS_Printf(player, "Loaded options")
						end
					end
				else
					player.friendlymenu_confirmpressed = 0
				end
				if (player.cmd.buttons & BT_USE)
					if (player.friendlymenu_refusepressed == 0)
						player.friendlymenu_refusepressed = 1
						S_StartSound(nil,sfx_frefus,player)
						player.freindlymenu_settings[2] = 0
						player.freindlymenu_settings[1] = 0
						COM_BufInsertText(player, "tunes frmenu")
					end
				else
					player.friendlymenu_refusepressed = 0
				end
			end
			
			//ADMIN STUFF
			if (player.freindlymenu_settings[2] == 2)
				kys(player, -50, 1, 4, 0, true)
				kys(player, 50, -1, -1, 3, true)
				if (CV_FindVar("freindly_roamer").value)
				and (player.freindlymenu_settings[1] == 1)
					movements(player, 50, 1, 1)
					movements(player, -50, -1, 1)
				end
				if (player.cmd.buttons & BT_JUMP)
					if (player.friendlymenu_confirmpressed == 0)
						S_StartSound(nil,sfx_fconfm,player)
						player.friendlymenu_confirmpressed = 1
						
						if (player.freindlymenu_settings[1] == 0)
							if (CV_FindVar("freindly_roamer").value)
								COM_BufInsertText(server, "freindly_roamer 0")
								CONS_Printf(player, "The roamer has been disabled")
							else
								COM_BufInsertText(server, "freindly_roamer 1")
								CONS_Printf(player, "The roamer has been enabled")
							end
						end
						
						if (player.freindlymenu_settings[1] == 2)
							if (CV_FindVar("freindly_roamerforceskin").value)
								COM_BufInsertText(server, "freindly_roamerforceskin 0")
								CONS_Printf(player, "No longer forced to use the Freindly to get a roamer")
							else
								COM_BufInsertText(server, "freindly_roamerforceskin 1")
								CONS_Printf(player, "It's now forced to use the Freindly to get a roamer")
							end
						end
						
						if (player.freindlymenu_settings[1] == 3)
							if (CV_FindVar("freindly_nerf").value)
								COM_BufInsertText(server, "freindly_nerf 0")
								CONS_Printf(player, "The Freind has been nerfed")
							else
								COM_BufInsertText(server, "freindly_nerf 1")
								CONS_Printf(player, "The Freind is now a menace")
							end
						end
						
					end
				else
					player.friendlymenu_confirmpressed = 0
				end
				if (player.cmd.buttons & BT_USE)
					if (player.friendlymenu_refusepressed == 0)
						player.friendlymenu_refusepressed = 1
						S_StartSound(nil,sfx_frefus,player)
						player.freindlymenu_settings[2] = 0
						player.freindlymenu_settings[1] = 1
					end
				else
					player.friendlymenu_refusepressed = 0
				end
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid and player.mo.skin == "freindlyfellow")
		if (player.freindlymenu == 1)
			player.powers[pw_nocontrol] = 2
			player.freindlymenutimer = $ + 1
		else
			player.freindlymenutimer = 0
		end
	end
end)

addHook("ShouldDamage", function(mo, guh)
	if not guh return end
	if (mo.valid) and (mo.player) and (mo.player.freindlymenu)
		return false
	end
end, MT_PLAYER)

local function drawMenu(v, player)
	if not (player.mo) return end
	if (player.playerstate == PST_DEAD) return end
	if not (player.freindlymenu) return end
	local menuDetail = {
		"Settings for client-side and or player settings.", 
		"Settings for server-side and or admin settings."
	}
	v.drawFill(0,0,320,200,0)
	v.drawScaled(160*FRACUNIT, 200*FRACUNIT, FRACUNIT, v.cachePatch("COSOMA"), V_PERPLAYER|V_SNAPTOBOTTOM, V_WHITEMAP)
	
	
	if (player.freindlymenu_settings[2] == 0)
		local menuColors = {V_WHITEMAP,V_WHITEMAP}
		menuColors[player.freindlymenu_settings[1]+1] = V_YELLOWMAP 
		v.draw(160, 40, v.cachePatch("FREFINE"),V_PERPLAYER|V_SNAPTOTOP) 
		v.drawString(160, 110, "USER SETTINGS", menuColors[1], "center")
		v.drawString(160, 120, "ADMIN SETTINGS", menuColors[2], "center")
	end
	
	
	if (player.freindlymenu_settings[2] == 1)
		menuDetail = {
			"Set your personal amount of roamers that will follow you everywhere.", 
			"Play the song that's iconic to the Friendly Fellow.",
			"Show the controls at the bottom of the screen in gameplay.",
			"Save your current settings.",
			"Load your current settings."
		}
		local menuColors = {V_WHITEMAP,V_WHITEMAP,V_WHITEMAP,V_WHITEMAP,V_WHITEMAP}
		local menuOptions = {CV_FindVar("freindly_music").value, CV_FindVar("freindly_aid").value}
		local text = "ROAMER AMOUNT FORCED BY ADMIN"
		for i = 1,2
			if (menuOptions[i] == 1) menuOptions[i] = "ON" else menuOptions[i] = "OFF" end
		end
		menuColors[player.freindlymenu_settings[1]+1] = V_YELLOWMAP 
		
		if not (CV_FindVar("freindly_roamer").value)
		or (CV_FindVar("freindly_roamerforceamount").value > 0)
			menuColors[1] = V_50TRANS|V_GRAYMAP
		end
		v.draw(160, 40, v.cachePatch("FUSER"),V_PERPLAYER|V_SNAPTOTOP) 
		v.drawString(160, 100, "PERSONAL ROAMER AMOUNT: "+player.freindlyamount, menuColors[1], "center")
		v.drawString(160, 110, "FREINDLY MUSIC: "+tostring(menuOptions[1]), menuColors[2], "center")
		v.drawString(160, 120, "CONTROL AID: "+tostring(menuOptions[2]), menuColors[3], "center")
		v.drawString(160, 140, "SAVE LOCAL OPTIONS", menuColors[4], "center")
		v.drawString(160, 150, "LOAD LOCAL OPTIONS", menuColors[5], "center")
		if (CV_FindVar("freindly_roamerforceamount").value > 0)
		or (CV_FindVar("freindly_roamer").value == 0)
			if (CV_FindVar("freindly_roamer").value == 0) text = "ROAMER DISABLED BY ADMIN" end
			v.drawString(160, 100, text, V_REDMAP, "thin-center")
		end
	end
	
	
	if (player.freindlymenu_settings[2] == 2)
		menuDetail = {
			"Enable or disable the roamers.",
			"Force a certain amount of roamers for every single player.",
			"Make the roamer only work if you are the Fellow.",
			"Nerf the Fellow in competitive gametypes."
		}
		local guh = CV_FindVar("freindly_roamerforceamount").value
		local menuOptions = {"OFF","OFF","OFF"}
		local menuColors = {V_WHITEMAP,V_WHITEMAP,V_WHITEMAP,V_WHITEMAP}
		menuColors[player.freindlymenu_settings[1]+1] = V_YELLOWMAP 
		if not (CV_FindVar("freindly_roamer").value)
			if (menuColors[2] == V_YELLOWMAP)
				menuColors[2] = V_YELLOWMAP|V_50TRANS
			else
				menuColors[2] = V_50TRANS
			end
		end
		if (guh == 0) guh = "OFF" end
		if (CV_FindVar("freindly_roamer").value) menuOptions[1] = "ON" end
		if (CV_FindVar("freindly_roamerforceskin").value) menuOptions[2] = "ON" end
		if (CV_FindVar("freindly_nerf").value) menuOptions[3] = "ON" end
		v.draw(160, 40, v.cachePatch("FADMIN"),V_PERPLAYER|V_SNAPTOTOP)
		v.drawString(160, 100, "ROAMER: "+menuOptions[1], menuColors[1], "center")
		v.drawString(160, 110, "FORCED ROAMER AMOUNT: "+guh, menuColors[2], "center")
		v.drawString(160, 120, "FORCED ROAMER W/ FREINDLY: "+tostring(menuOptions[2]), menuColors[3], "center")
		v.drawString(160, 130, "NERFED: "+tostring(menuOptions[3]), menuColors[4], "center")
	end
	v.draw((player.freindlymenutimer)%320,0, v.cachePatch("COSHUDB"),V_PERPLAYER|V_SNAPTOTOP)
	v.draw((player.freindlymenutimer)%320,200, v.cachePatch("COSHUDA"),V_PERPLAYER|V_SNAPTOBOTTOM)

	v.drawString(160, 180, menuDetail[player.freindlymenu_settings[1]+1], V_SNAPTOBOTTOM, "thin-center")
	if (player.freindlymenu_settings[2] == 1)
	and (player.freindlymenu_settings[1] == 0)
		v.drawString(160, 190, "Doesn't work if an admin forced an amount and or disabled the roamers.", V_SNAPTOBOTTOM|V_REDMAP, "thin-center")
	end
end

local function drawAid(v, player)
	if not (player.mo) return end
	if (player.playerstate == PST_DEAD) return end
	if (player.mo.skin ~= "freindlyfellow") return end
	if not (cv_fwaid.value) return end
	if (player.freindlymenu) return end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) return end
	local grounded = P_IsObjectOnGround(player.mo)
	local spinDetails = {V_30TRANS, "\x89 Spin: Spin Jab"}
	local blastDetails = V_30TRANS
	local jumpDetails = V_60TRANS
	local s = "s"
	if not grounded then jumpDetails = V_30TRANS end
	if (player.cmd.buttons & BT_USE) and grounded then spinDetails[1] = V_60TRANS end
	if (player.freindlywilldrill) then
		spinDetails[1] = V_60TRANS 
		jumpDetails = V_80TRANS
		blastDetails = V_80TRANS
	end
	if (player.freindlyblasted == 2) then  
		blastDetails = V_60TRANS
		jumpDetails = V_80TRANS
	end
	if not grounded then 
		spinDetails[2] = "\x85 Double Spin: Stomp" 
		if canBeNerfed(player)
			blastDetails = V_80TRANS
		end
		v.drawString(20, 154, "\x84 Spin + Jump: Starjump", blastDetails|V_ALLOWLOWERCASE|V_SNAPTOBOTTOM|V_SNAPTOLEFT, "small")
	end 
	
	if isInBattle(player) then s = "" end
	if not canBeNerfed(player)
		v.drawString(220, 144, "\x8A Jump: Freindly Jump"+s, jumpDetails|V_ALLOWLOWERCASE|V_SNAPTOBOTTOM|V_SNAPTORIGHT, "small")
	end
	v.drawString(20, 144, spinDetails[2], spinDetails[1]|V_ALLOWLOWERCASE|V_SNAPTOBOTTOM|V_SNAPTOLEFT, "small")
	v.drawString(20, 134, "\x82 Custom 1: Yah", V_30TRANS|V_ALLOWLOWERCASE|V_SNAPTOBOTTOM|V_SNAPTOLEFT, "small")
end

hud.add(drawAid, "game")
hud.add(drawMenu, "game")