freeslot("sfx_fbwomp", "sfx_fpain", "sfx_fscrol", "sfx_fconfm", "sfx_frefus", "sfx_fpop", "sfx_fchar", "sfx_fchbr", "sfx_fpows", "sfx_sya", "sfx_fbla", "sfx_syaa", "sfx_stjump", "sfx_strjump", "spr_frnd")
freeslot("MT_FREINDLYROSY", "MT_UNFREINDLY_KILL","MT_FREINDLYFOLLOWER", "MT_UNFREINDLY", "MT_UNFREINDLYTARGET", "MT_FREINDLYSPLATURE")
freeslot("S_UNFREINDLY", "S_FREINDLY", "S_FREINDLYROSY", "S_FREINDLYSPLATURE")

sfxinfo[sfx_fbwomp].caption = "Bwoomp"
sfxinfo[sfx_sya].caption = "Yah"
sfxinfo[sfx_fbla].caption = "Freindly Blasture!"
sfxinfo[sfx_strjum].caption = "Wooosh"
sfxinfo[sfx_fpows].caption = "Hit it."
sfxinfo[sfx_fchar].caption = "Cheering"
sfxinfo[sfx_fchbr].caption = "Clapping"
sfxinfo[sfx_syaa].caption = "Yuuuuuh"
sfxinfo[sfx_fpop].caption = "Pop"
sfxinfo[sfx_fscrol].caption = "Scroll"
sfxinfo[sfx_fconfm].caption = "Confirm"
sfxinfo[sfx_frefus].caption = "Back"
sfxinfo[sfx_fpain].caption = "Screaming In Pain"

states[S_FREINDLYSPLATURE] = {
	sprite = SPR_FRND,
	frame = FF_PAPERSPRITE|D,
	tics = -1,
	nextframe = S_FREINDLYSPLATURE,
	var1 = 0,
	var2 = 0
}

states[S_UNFREINDLY] = {
	sprite = SPR_FRND,
	frame = A,
	tics = -1,
	nextframe = S_UNFREINDLY,
	var1 = 0,
	var2 = 0
}

states[S_FREINDLY] = {
	sprite = SPR_FRND,
	frame = FF_PAPERSPRITE|B,
	tics = -1,
	nextframe = S_FREINDLY,
	var1 = 0,
	var2 = 0
}

mobjinfo[MT_UNFREINDLY] = {
	doomednum = -1,
    spawnstate = S_UNFREINDLY,
	spawnhealth = 100000,
    reactiontime = 1,
    speed = 35*FRACUNIT,
    radius = 24*FRACUNIT,
    height = 24*FRACUNIT,
    flags = MF_SPECIAL|MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

mobjinfo[MT_FREINDLYROSY] = {
	doomednum = -1,
    spawnstate = S_FREINDLYROSY,
	spawnhealth = 100000,
	activesound = sfx_s3k7b,
    radius = 24*FRACUNIT,
    height = 24*FRACUNIT,
	flags = MF_BOUNCE
}

states[S_FREINDLYROSY] = {
	sprite = SPR_ROSY,
	frame = N,
	tics = -1,
	nextframe = S_NULL,
	var1 = 0,
	var2 = 0
}

mobjinfo[MT_UNFREINDLY_KILL] = {
	doomednum = -1,
    spawnstate = S_UNFREINDLY,
	spawnhealth = 100000,
    reactiontime = 1,
    speed = 35*FRACUNIT,
    radius = 24*FRACUNIT,
    height = 24*FRACUNIT,
    flags = MF_SPECIAL|MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

mobjinfo[MT_FREINDLYSPLATURE] = {
	doomednum = -1,
    spawnstate = S_FREINDLYSPLATURE,
	spawnhealth = 100000,
    reactiontime = 1,
    speed = 35*FRACUNIT,
    radius = 24*FRACUNIT,
    height = 24*FRACUNIT,
    flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

mobjinfo[MT_FREINDLYFOLLOWER] = {
	doomednum = -1,
    spawnstate = S_FREINDLY,
	spawnhealth = 100000,
    reactiontime = 1,
    speed = 35*FRACUNIT,
    radius = 24*FRACUNIT,
    height = 24*FRACUNIT,
    flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

mobjinfo[MT_UNFREINDLYTARGET] = {
	doomednum = -1,
    spawnstate = S_INVISIBLE,
    spawnhealth = 100000,
    reactiontime = 1000,
    speed = 24*FRACUNIT,
    radius = 24*FRACUNIT,
    height = 24*FRACUNIT,
    dispoffset = 0,
    mass = 1000,
    flags = MF_SPECIAL|MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

freeslot("SKINCOLOR_FREINDLY")
skincolors[SKINCOLOR_FREINDLY] = {
	name = "freindly!",
    ramp = {80,81,82,83,73,74,74,65,65,66,67,67,68,68,71,71},
    invcolor = SKINCOLOR_SAPPHIRE,
    invshade = 7,
    chatcolor = V_YELLOWMAP,
    accessible = true
}

freeslot('tol_arena','tol_survival','tol_cp','tol_diamond','tol_battlectf','tol_bigarena','tol_battle','tol_eggrobotag')
